import java.awt.*;
import javax.swing.*;
import java.util.*;
import java.awt.event.*;

/**
 * Title:        spider - SpiderBox
 * Description:  Projekt zur Einfuehrung der Objektorientierten Programmierung
 * Copyright:    Copyright (c) 2005
 * Company:      MezMedia
 * @author Oliver Mezger
 * @version 1.4
 */

public class SpiderBox extends JFrame {
  private MyPanel mPan = new MyPanel();
 
  public SpiderBox() {
    getContentPane().add(mPan);
    addWindowListener(new WindowAdapter(){  // Objekt soll beendet werden knnen
       public void windowClosing(WindowEvent e) {
         System.exit(0);
       }
    }); 
    addKeyListener(new KeyAdapter(){
        public void keyPressed(KeyEvent e){
            switch (e.getKeyCode()){
               case KeyEvent.VK_RIGHT: mPan.ortX+=10; break;
               case KeyEvent.VK_LEFT:  mPan.ortX-=10;  break;
            }
        }
    });
  }  
}

class MyPanel extends JPanel implements Runnable { // zustzliche Schnittstelle Runnable
  private JLabel versi = new JLabel("Spider 1.4 (c) MezMedia");
  private JButton exit = new JButton("Exit");
  public int ortX= 50,ortY=500;
  private Spider anna = new Spider(100,100,30,Color.red);
  //private Spider bert = new Spider(200,200,20,Color.green);
  
  public MyPanel(){
    setBackground(Color.yellow);
    setLayout(new FlowLayout());
    add(versi);
    add(exit);
    exit.addMouseListener(new java.awt.event.MouseAdapter() {
      public void mouseClicked(MouseEvent e) {
        System.exit(0);
      }
    });
    exit.setFocusable(false); // damit der Button nich die KeyEvents wegschnappt kriegt er nicht den Fokus.
    addMouseListener(new java.awt.event.MouseAdapter() {
      public void mousePressed(MouseEvent e) {
        canvas_mousePressed(e);
      }
    });
            
    Thread liveDaemon = new Thread(this);  // neuen Thread erzeugen
    liveDaemon.start();  // Thread starten
  }
  public void paintComponent(Graphics g)  {
    super.paintComponent(g);
    g.setColor(Color.blue);
    g.fillRect(ortX, ortY, 60, 10);
    anna.malen(g);
    //bert.malen(g);
  }  
  public void canvas_mousePressed(MouseEvent e) {
    ortX=e.getX();
    ortY=e.getY();
    repaint();
  }
  public void run() {// das ist der Thread, hier steckt das Leben drin
    while (true){ // solange immer
      anna.leben(ortX,ortY);  // anna leben lassen
      //bert.leben(ortX,ortY);  // bert leben lasssen
      repaint();     // neu zeichnen
      try {
        Thread.sleep (40);  // ein wenig schlafen
      }
      catch (InterruptedException ex){
      }
    }  
  }
}